<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	https://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|	$route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:	my-controller/index	-> my_controller/index
|		my-controller/my-method	-> my_controller/my_method
*/

$route['default_controller'] = 'Home';

$route[':any'] = 'Home/website_url';


// admin routes
$route['admin/login'] = 'backend/Login'; 
$route['admin/logout'] = 'backend/Login/logout';
$route['admin/dashboard'] = 'backend/Dashboard';


$route['admin/domain'] = 'backend/domain';
$route['admin/consultent'] = 'backend/consultent';

$route['admin/assign-consultent/:any'] = 'backend/domain/assign_consultent';

$route['admin/my-leave'] = 'backend/my_leave';
$route['admin/consultent-availability/:any'] = 'backend/consultent/consultent_availability';


$route['admin/user-list'] = 'backend/users';

$route['admin/report'] = 'backend/report';

$route['admin/my-meeting'] = 'backend/my_leave/my_meeting';



$route['admin/accept-meeting'] = 'Calender';
$route['admin/reject-meeting'] = 'Calender/reject_meeting';

$route['admin/reject-meeting-final'] = 'Calender/reject_meeting_final';

$route['admin/status'] = 'Calender/status';

$route['admin/round_robin'] = 'Calender/round_robin';

$route['admin/holiday/:any'] = 'backend/domain/holiday';

$route['admin/email_notification_admin'] = 'email_notification/email_notification_admin';
$route['admin/email_notification_user'] = 'email_notification/email_notification_user';

$route['admin/report_everyday_consultent'] = 'report_everyday/report_everyday_consultent';

$route['404_override'] = '';
$route['translate_uri_dashes'] = FALSE;


