<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Domain extends CI_Controller {
public $data;
public function __construct()
{
	parent::__construct();
	
	if($this->session->userdata('loginDetail') ==NULL || $this->session->userdata('loginDetail')->user_type!='admin'){
      redirect('admin/login');
    }

    $this->data['page_title'] = "Domain";
		
}

public function index()
{	
 	
 	$this->db->order_by('id', 'DESC');
	$result=$this->db->get('tbl_domain')->result();

    $this->data['totalRecords'] = count($result);
    $this->data['result'] = $result;
      		
	$this->load->view('backend/template/admin_header',$this->data);
	$this->load->view('backend/template/admin_leftmenu');
	$this->load->view('backend/domain/listing',$this->data);
	$this->load->view('backend/template/admin_footer');
    	
}


	public function save(){


		$domain_name = $this->input->post('domain_name');

		if($this->input->post('id')!=''){
		    
		    $this->db->where('id', $this->input->post('id'));		  		
    		$row_blog=$this->db->get('tbl_domain')->row();
    
    		if(!empty($_FILES['domain_logo']['name'])){
    			
    			$path=$row_blog->domain_logo;
    				if(!empty($path)){
    				unlink(FCPATH. 'assets/img/blog_image/'.$path);	
    			}
    
    	        $config['upload_path'] = FCPATH.'assets/domain';
    	        $config['allowed_types'] = 'jpg|jpeg|png';
    	        $config['max_size']      = 20000;
    	        $config['file_name'] = $_FILES['domain_logo']['name'];
    	        
    	        //Load upload library and initialize configuration
    	        $this->load->library('upload',$config);
    	        $this->upload->initialize($config);
    	        
    	        if($this->upload->do_upload('domain_logo')){
    	            $uploadData = $this->upload->data();
    	            $gallery_image = $uploadData['file_name'];
    	        }else{
    	            $gallery_image = '';
    	            
    				die(json_encode(['status' => 0, 'msg' => 'Allowed .jpg, .jpeg & max 20mb!']));
    	        }
    
    	    }else{
    	    	$gallery_image = $row_blog->blog_img;
    	    }

			$data = [
				'domain_name'=>$domain_name,
				'domain_logo'=>$gallery_image,
			];

			$this->db->where('id', $this->input->post('id'));	
			$result = $this->db->update('tbl_domain', $data);

			if($result){
	  			die(json_encode(['status' => 1, 'msg' => 'Domain updated successful']));
		  	}else{
		  		die(json_encode(['status' => 0, 'msg' => 'Wrong']));
		  	}

		}else{

			$str=rand();
			$result = md5($str);
			
			if(!empty($_FILES['domain_logo']['name'])){
			
    	        $config['upload_path'] = FCPATH.'assets/domain';
    	        $config['allowed_types'] = 'jpg|jpeg|png';
    	        $config['max_size']      = 20000;
    	        $config['file_name'] = $_FILES['domain_logo']['name'];
    	        
    	        //Load upload library and initialize configuration
    	        $this->load->library('upload',$config);
    	        $this->upload->initialize($config);
    	        
    	        if($this->upload->do_upload('domain_logo')){
    	            $uploadData = $this->upload->data();
    	            $gallery_image = $uploadData['file_name'];
    	        }else{
    	            $gallery_image = '';
    	            die(json_encode(['status' => 0, 'msg' => 'Allowed .jpg, .jpeg & max 20mb!']));
    	        }
    
    	    }

			$data = [

				'domain_name'=>$domain_name,
				'created_by'=>$this->session->userdata('loginDetail')->id,
				'url_string'=>$result,
				'domain_logo'=>$gallery_image,

			];

			$result = $this->db->insert('tbl_domain', $data);

			if($result){
	  			die(json_encode(['status' => 1, 'msg' => 'Domain created successful']));
		  	}else{
		  		die(json_encode(['status' => 0, 'msg' => 'Wrong']));
		  	}
		}

	}


	public function assign_consultent(){

		$id = $this->uri->segment(3);

		


		$results = $this->db->select('tbl_assign_consultent.*')
        ->select('tbl_admin.name as name,tbl_admin.email as email,tbl_admin.id as consultent_id')

	     ->from('tbl_assign_consultent as tbl_assign_consultent')
	     ->join('tbl_admin as tbl_admin', 'tbl_assign_consultent.consultent_id = tbl_admin.id', 'LEFT')
	     ->join('tbl_domain as tbl_domain', 'tbl_assign_consultent.domain_id = tbl_domain.id', 'LEFT')
	     ->where('tbl_domain.id', $id)
	     ->order_by('tbl_assign_consultent.position', 'ASC')
	     ->get()->result();

	    $this->data['result'] = $results;


	    $this->db->where('user_type', 'consultant');	
		$this->data['consultent'] = $this->db->get('tbl_admin')->result();


		$this->load->view('backend/template/admin_header',$this->data);
		$this->load->view('backend/template/admin_leftmenu');
		$this->load->view('backend/domain/assign_consultent',$this->data);
		$this->load->view('backend/template/admin_footer');
		
	}


	public function assign_consultent_save(){


		$consultent_id = $this->input->post('consultent_id');
		$position = $this->input->post('position');
		$domain_id = $this->input->post('domain_id');

		if($this->input->post('id')!=''){

			$data = [
				'consultent_id'=>$consultent_id,
				'position'=>$position,
				'domain_id'=>$domain_id,
			];

			$this->db->where('id', $this->input->post('id'));	
			$result = $this->db->update('tbl_assign_consultent', $data);

			if($result){
	  			die(json_encode(['status' => 1, 'msg' => 'Domain updated successful']));
		  	}else{
		  		die(json_encode(['status' => 0, 'msg' => 'Wrong']));
		  	}

		}else{

			$data = [

				'consultent_id'=>$consultent_id,
				'position'=>$position,
				'domain_id'=>$domain_id,
				'assign_by'=>$this->session->userdata('loginDetail')->id,

			];

			$result = $this->db->insert('tbl_assign_consultent', $data);

			if($result){
	  			die(json_encode(['status' => 1, 'msg' => 'Domain created successful']));
		  	}else{
		  		die(json_encode(['status' => 0, 'msg' => 'Wrong']));
		  	}
		}


	}
	
	
	public function holiday(){

		$domain_id = $this->uri->segment(3);

		$this->db->where('domain_id', $domain_id);
		$this->data['holiday']=$this->db->get('tbl_holiday')->result();


		$this->load->view('backend/template/admin_header',$this->data);
		$this->load->view('backend/template/admin_leftmenu');
		$this->load->view('backend/domain/holiday',$this->data);
		$this->load->view('backend/template/admin_footer');


	}


	public function holiday_save(){

		$title = $this->input->post('title');
		$description = $this->input->post('description');
		$start_datetime = $this->input->post('start_datetime');
		$actual_end_datetime = $this->input->post('end_datetime');

		$domain_id = $this->input->post('domain_id');


		$end_datetime = date('Y-m-d', strtotime($this->input->post('end_datetime'). ' + 1 days'));

		if($this->input->post('id')!=''){

			$data = [
				'title'=>$title,
				'description'=>$description,
				'start_datetime'=>$start_datetime,
				'end_datetime'=>$end_datetime,
				'actual_end_datetime'=>$actual_end_datetime,
				'domain_id'=>$domain_id,
			];

			$this->db->where('id', $this->input->post('id'));	
			$result = $this->db->update('tbl_holiday', $data);

			if($result){
	  			die(json_encode(['status' => 1, 'msg' => 'Holiday updated successful']));
		  	}else{
		  		die(json_encode(['status' => 0, 'msg' => 'Wrong']));
		  	}

		}else{

			$data = [

				'title'=>$title,
				'description'=>$description,
				'start_datetime'=>$start_datetime,
				'end_datetime'=>$end_datetime,
				'actual_end_datetime'=>$actual_end_datetime,
				'domain_id'=>$domain_id,
			];

			$result = $this->db->insert('tbl_holiday', $data);

			if($result){
	  			die(json_encode(['status' => 1, 'msg' => 'Holiday created successful']));
		  	}else{
		  		die(json_encode(['status' => 0, 'msg' => 'Wrong']));
		  	}
		}

	}



}
