<!doctype html>
<html lang="en">
  <head>
    <link href="images/logo.png" rel="icon" type="image/png">
  	<title>Argentum Calendar</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
	<link href="https://fonts.googleapis.com/css?family=Lato:300,400,700&display=swap" rel="stylesheet">
	<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css">	
	<link rel="stylesheet" href="<?=base_url()?>css/bootstrap.min@@@@.css">
	<link rel="stylesheet" href="<?=base_url()?>css/calendar.css">
	<link rel="stylesheet" href="<?=base_url()?>css/style.css">	
    <style type="text/css">
        #user_form .error{
            color: red;
        }
        .site_logo{
            background-color: #f5f5f5;
            padding: 10px;
        }
        .site_logo img{
            height: 70px;
        }
        #user_second_form .error{
           color: red; 
        }
        .site-phone-number {
            text-align: center;
            margin-top: 15px;
        }
        .site-phone-number .num-cont {
            border: 2px solid #003087;
            border-radius: 20px;
            display: inline-block;
        }
        .site-phone-number .num-cont i {
            background-color: #003087;
            color: #fff;
            padding: 0 20px 0 25px;
            float: left;
            border-radius: 16px 0 0 16px;
            line-height: 40px;
            font-size: 25px;
        }
        .site-phone-number .num-cont span {
            float: left;
            margin: 0 25px 0 15px;
            color: #003087;
            font-weight: bold;
            font-size: 25px;
            line-height: 40px;
        }
        .site-phone-number .num-cont:hover,
        .site-phone-number .num-cont:focus, 
        .site-phone-number .num-cont:active {
            background-color: #003087;
        }
        .site-phone-number .num-cont:hover i,
        .site-phone-number .num-cont:focus i, 
        .site-phone-number .num-cont:active i {
            background-color: #fff;
            color: #003087;
            border-radius: 19px 0 0 19px;
        }
        .site-phone-number .num-cont:hover span,
        .site-phone-number .num-cont:focus span, 
        .site-phone-number .num-cont:active span {
            color: #fff;
        }
    </style>
	</head>
	<body>
		<input type="hidden" name="base_url" id="base_url" value="<?=base_url()?>">
        <section class="ftco-section">
            <div class="container">
                <div class="row">
                    <div class="col-md-12">
                        <?php if($domain_name->domain_logo!=''){ ?>
                            <div class="text-center site_logo" style="box-shadow: 0 1px 8px 0 rgba(0,0,0,.08);">
                                <img src="<?php echo base_url() .'assets/';?>domain/<?php echo $domain_name->domain_logo; ?>">
                                <div class="site-phone-number">
                                    <a class="num-cont" href="tel:<?=$domain_name->phone_number?>"><i class="fa fa-phone" aria-hidden="true"></i><span><?=$domain_name->phone_number?></span></a>
                                </div>
                            </div>
                        <?php } ?>
                        
                        <div class="content w-100" id="full_content" style="margin-top: 0px;">
                            <div class="responsive-top-logo"><img class="logo" src="images/logo.png" alt="Argentum Calendar"> Argentum Calendar</div>
                            <div class="calendar-container" id="calendar_sec">
                                <div class="calendar"> 
                                    <div class="year-header"> 
                                        <span class="left-button fa fa-chevron-left" id="prev"> </span> 
                                        <span class="year" id="label"></span> 
                                        <span class="right-button fa fa-chevron-right" id="next"> </span>
                                    </div> 
                                    <div id="loading-bar-spinner" class="spinner"><div class="spinner-icon"></div></div>
                                    <table class="months-table w-100"> 
                                        <tbody>
                                            <tr class="months-row">
                                            <td class="month">Jan</td> 
                                            <td class="month">Feb</td> 
                                            <td class="month">Mar</td> 
                                            <td class="month">Apr</td> 
                                            <td class="month">May</td> 
                                            <td class="month">Jun</td> 
                                            <td class="month">Jul</td>
                                            <td class="month">Aug</td> 
                                            <td class="month">Sep</td> 
                                            <td class="month">Oct</td>          
                                            <td class="month">Nov</td>
                                            <td class="month">Dec</td>
                                            </tr>
                                        </tbody>
                                    </table>
                                    <table class="days-table w-100"> 
                                        <td class="day">Sun</td> 
                                        <td class="day">Mon</td> 
                                        <td class="day">Tue</td> 
                                        <td class="day">Wed</td> 
                                        <td class="day">Thu</td> 
                                        <td class="day">Fri</td> 
                                        <td class="day">Sat</td>
                                    </table> 
                                    <div class="frame"> 
                                        <table class="dates-table w-100"> 
                                            <tbody class="tbody">             
                                            </tbody> 
                                        </table>
                                    </div>
                                    <input type="hidden" name="current_year" id="current_year" value="">
                                    
                                    <div class="timezone-cont">
                                        <?php
                                            $ip_val = $_SERVER['REMOTE_ADDR'];
                                            //echo $ip_val;
                                    // 		$ip_val = '162.251.62.156';
                                            $dataArray = json_decode(file_get_contents("http://www.geoplugin.net/json.gp?ip=".$ip_val));
                                            if ($dataArray->geoplugin_timezone != '') {
                                                $get_time_zone = $dataArray->geoplugin_timezone;
                                            }else{
                                                $get_time_zone = '';
                                            }


                                            $time_zone=$this->db->get('tbl_timezone')->result();
                                        ?>
                                        <select name="timezone" id="timezone">
                                            <?php foreach ($time_zone as $key => $value) { 
                                                $selected = '';
                                                if($value->timezone==$get_time_zone){
                                                    $selected='selected';
                                                }

                                            ?>
                                            <option value="<?=$value->timezone?>" <?=$selected?>><?=$value->timezone?></option>
                                            <?php } ?>
                                        </select>
                                    </div>
                                    <!-- <button class="button" id="add-button">Add Event</button> -->
                                </div>
                                <div class="calendar-time" style="display: none;">
                                    <h2 class="calendar-time-title">Select Time</h2>
                                    <div class="time-cont">

                                    </div>								
                                </div>


                            </div>
                            <!-- <div class="events-container">
                            </div> -->
                            <div class="events-container-static">
                                <div class="row justify-content-center">
                                    <div class="col-md-12 text-center mb-5 top-logo-cont">
                                        <h1 class="heading-section"><img class="logo" src="images/logo.png" alt="Argentum Calendar" /> Argentum Calendar</h1>
                                    </div>
                                </div>
                            </div>
                            <div class="dialog" id="dialog">
                                <div class="add-event-dialog">
                                    <h2 class="dialog-header">Enter Details</h2>
                                    <form class="form" id="user_form">
                                        <div class="form-container">
                                            <div>
                                                <label class="form-label">Name *</label>
                                                <input class="input first_name" type="text" name="name" id="name">
                                            </div>
                                            <div>
                                                <label class="form-label">Email *</label>
                                                <input class="input first_email" type="email" name="email" id="email">
                                                
                                            </div>
                                            <div class="clearfix"></div>

                                            <div id="otp_section">

                                            </div>
                                            <input type="hidden" name="otp_verify" id="otp_verify" value="0">
                                            <button class="button button-white" id="ok_button" type="submit">Verify Email</button>									
                                        </div>
                                    </form>
                                    <form class="form" id="user_second_form" style="display: none;">
                                        <div class="form-container">
                                            <div>
                                                <label class="form-label">Name *</label>
                                                <input class="input name" type="text" name="name" id="name" readonly="true">
                                            </div>
                                            <div>
                                                <label class="form-label">Email *</label>
                                                <input class="input email" type="email" name="email" id="email" readonly="true">
                                                <span style="color:green; display: none;" id="success_message">Email verified successfully</span>
                                            </div>
                                            <div>
                                                <label class="form-label">Phone *</label>
                                                <input class="input isnumber" type="text" name="phone" id="phone">
                                            </div>
                                            <div class="clearfix"></div>
                                            <input class="button btn-light-small" type="button" onclick="guest_emails()" value="Add Guests" style="margin-bottom: 8px;">
                                            <input class="button btn-light-small-two" type="button" onclick="guest_notes()" value="Add Note" style="background-color: #4a6ac3; margin-bottom: 8px; margin-left: 10px; border-radius: 0; padding: 5px 10px;">
                                            <div class="clearfix"></div>
                                            <div id="guest_email_s" style="display: none;">
                                                <label class="form-label">Guest Email(s)</label>
                                                <input class="input" type="email" name="guest_email" id="guest_email">
                                            </div>
                                            <!--<label class="form-label">Please share anything that will help prepare for our meeting.</label>-->
                                            <textarea id="descricption" class="input" name="descricption" placeholder="Type Your Meeting Notes" style="display: none; background-color: #e4ebfe;padding: 5px 10px;color: #000;border-radius: 5px;height: 100px; resize: none;"></textarea>
                                            <input type="hidden" name="site_id" id="site_id" value="<?=$site_id?>">
                                            <input type="hidden" name="user_time_zone" id="user_time_zone" value="">
                                            <input type="hidden" name="user_date" id="user_date" value="">
                                            <input type="hidden" name="user_time_twenty" id="user_time_twenty" value="">
                                            <input type="hidden" name="user_times" id="user_times" value="">
                                            <button class="button button-white" id="ok_button_second" type="submit" style="margin-top: 10px;">Submit</button>									
                                        </div>
                                    </form>
                                    <div class="success_section" id="success_section" style="display: none;">

                                        <div id='upper-side'>
                                            <i class="fa fa-check-circle-o" aria-hidden="true"></i>
                                              <h3 id='status'>
                                              Success
                                            </h3>
                                          </div>
                                          <div id='lower-side'>
                                            <p id='message'>
                                              Thank you for connecting with us, We will get back to you shortly.
                                            </p>
                                          </div>

                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </section>

<script src="<?=base_url()?>js/jquery.min.js"></script>
<script src="<?=base_url()?>js/popper.js"></script>
<script src="<?=base_url()?>js/bootstrap.min.js"></script>
<script src="<?=base_url()?>js/main.js"></script>

<script src="https://ajax.aspnetcdn.com/ajax/jquery.validate/1.11.1/jquery.validate.min.js"></script>
<script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>


<script type="text/javascript">
	function click_shadule(times, vals, time_twenty, user_date, timezone){

        var new_timezone = $("#timezone").val();
		
		var user_c_date ='';
		
		var site_id = $("#site_id").val();


		$.ajax({
              url: "<?=base_url().'home/consultent_avale_check'?>",
              type: 'POST',                    
              
              data: {times:times,time_twenty:time_twenty,user_date:user_date,timezone:new_timezone,site_id:site_id},
              beforeSend:function(){
                
              },
              success: function(data){
              
                  var obj=JSON.parse(data);
                  if(obj.status==1){
                      
                    $.ajax({
                        url: "<?=BASE_URL.'home/user_date_convert'?>",
                        type: 'POST',                    
                        data: {user_date:user_date},
                        beforeSend:function(){
                          
                        },
                        success: function(data){
                        
                          user_c_date = data; 
                          
                          swal({
    					        title:times+', '+user_c_date,
    					        // text: times,
    					        icon: "warning",
    					        buttons: ["Cancel", "Confirm"],
    					    }).then((value) => {
    
    					    	if(value){
    					    		
    						    	var html = '<div class="col-md-12 text-center mb-5 top-logo-cont one"><h1 class="heading-section"><img class="logo" src="images/logo.png" alt="Argentum Calendar" /> Argentum Calendar</h1></div><div class="event-card"><div class="event-name"><p class="event-schedule"><i class="fa fa-calendar" aria-hidden="true"></i> '+times+', '+user_c_date+'</p><p class="event-timezone"><i class="fa fa-globe" aria-hidden="true"></i> '+new_timezone+'</p></div></div>';
    
    							    $("#calendar_sec").html(html);
    							    $("#dialog").toggle('show');
    
    
    							    $("#user_time_zone").val(new_timezone);
    							    $("#user_date").val(user_date);
    							    $("#user_time_twenty").val(time_twenty);
    							    $("#user_times").val(times);
    							    
    							    $("#full_content").addClass("full_content");
    
    							}
    
    					    });
                
                        }
                    });
                    
                    
                    
                  }else if(obj.status==0){
                           
                    	swal({
                          title: obj.msg,
                          // text: obj.msg,
                          icon: "warning",
                        })                                       
                  }else{
                  	
                  }
                  

              }
          });


		

	}

	function guest_emails(){
		$("#guest_email_s").toggle('show');
		//$(".btn-light-small").toggle('hide');
	}
    function guest_notes(){
		$("#descricption").toggle('show');
		//$(".btn-light-small-two").toggle('hide');
	}


	$("#user_form").validate({
 
          rules : {
            name : {
                required : true,
                
            }, 
            email : {
                required : true,
                
            }, 
            
        }, 
        messages : {
            name : {
                required : "This field is required",
            },                                
            email : {
                required : "This field is required",
            },
            
        },
        submitHandler: function(form) {

            var form = $('#user_form')[0];
            var formData = new FormData(form);
            event.preventDefault();

            if($("#otp_verify").val()==0){

	          $.ajax({
	                  url: "<?=base_url().'home/email_verify'?>",
	                  type: 'POST',                    
	                  processData: false,
	                  contentType: false,
	                  data: formData,
	                  beforeSend:function(){
	                    $('#ok_button').html('Please Wait...');
	                    $('#ok_button').attr('disabled','disabled');
	                  },
	                  success: function(data){
	                  
	                      var obj=JSON.parse(data);
	                      if(obj.status==1){
	                        $('#ok_button').removeAttr('disabled');
	                        $('#ok_button').html('Submit');

	                        swal({
	                          title: obj.msg,
	                          // text: obj.msg,
	                          icon: "success",
	                        });

	                        $("#otp_verify").val(1);

	                        var html = '<label class="form-label">OTP(One Time Password) *</label><input type="text" class="input" name="final_otp" id="final_otp" required="" minlength="6" maxlength="6" style="background-color: rgba(255, 255, 255, 0.2);height: 30px;padding: 3px 10px;"><a href="javascript:void(0)" id="resend_otp" style="float: right; color: #7576fe;text-decoration: underline;font-size: 13px; display: none;" onclick="resend_otp()">Resent OTP</a>';
	                        $("#otp_section").html(html);

	                        $("#resend_otp").show();
	                        
	                      }else{
	                            $('#ok_button').removeAttr('disabled');
	                        	$('#ok_button').html('Verify Email');   
	                        	swal({
		                          title: obj.msg,
		                          // text: obj.msg,
		                          icon: "warning",
		                        })                                       
	                      }
	                      

	                  }
	              });

	      	}else{
	      		

	      		$.ajax({
	                  url: "<?=base_url().'home/otp_verify'?>",
	                  type: 'POST',                    
	                  processData: false,
	                  contentType: false,
	                  data: formData,
	                  beforeSend:function(){
	                    $('#ok_button').html('Please Wait...');
	                    $('#ok_button').attr('disabled','disabled');
	                  },
	                  success: function(data){
	                  
	                      var obj=JSON.parse(data);
	                      if(obj.status==1){
	                        $('#ok_button').removeAttr('disabled');
	                        $('#ok_button').html('Submit');

	                        $("#success_message").show();

	                        $(".name").val($(".first_name").val());
	                        $(".email").val($(".first_email").val());

	                        $("#user_form").toggle('hide');
	                        $("#user_second_form").toggle('show');
	                        
	                      }else if(obj.status==0){
	                            $('#ok_button').removeAttr('disabled');
	                        	$('#ok_button').html('Submit');   
	                        	swal({
		                          title: obj.msg,
		                          // text: obj.msg,
		                          icon: "warning",
		                        })                                       
	                      }else{
	                      	
	                      }
	                      

	                  }
	              });


	      	}

          
          }
  });



$("#user_second_form").validate({
 
          rules : {
            name : {
                required : true,
                
            }, 
            email : {
                required : true,
                
            }, 
            phone : {
                required : true,
                
            },
            
        }, 
        messages : {
            name : {
                required : "This field is required",
            },                                
            email : {
                required : "This field is required",
            },
            phone : {
                required : "This field is required",
            },
            
        },
        submitHandler: function(form) {

            var form = $('#user_second_form')[0];
            var formData = new FormData(form);
            event.preventDefault();

            

	          $.ajax({
	                  url: "<?=base_url().'home/final_submit'?>",
	                  type: 'POST',                    
	                  processData: false,
	                  contentType: false,
	                  data: formData,
	                  beforeSend:function(){
	                    $('#ok_button_second').html('Please Wait...');
	                    $('#ok_button_second').attr('disabled','disabled');
	                  },
	                  success: function(data){
	                  
	                      var obj=JSON.parse(data);
	                      if(obj.status==1){
	                        $('#ok_button_second').removeAttr('disabled');
	                        $('#ok_button_second').html('Submit');

	                       // swal({
	                       //   title: 'Success!',
	                       //   text: obj.msg,
	                       //   icon: "success",
	                       // });
	                       
	                       $(".dialog-header").hide();
	                       $("#user_second_form").toggle('hide');
	                       $("#success_section").toggle('show');

	                        $(".name").val('');
	                        $(".email").val('');
	                        $("#guest_email").val('');
	                        $("#descricption").val('');
	                        
	                      }else if(obj.status==0){
	                            $('#ok_button_second').removeAttr('disabled');
	                        	$('#ok_button_second').html('Submit');   
	                        	swal({
		                          title: obj.msg,
		                          // text: obj.msg,
		                          icon: "warning",
		                        })                                       
	                      }else{
	                      	
	                      }
	                      

	                  }
	              });

	      	

          
          }
  });


	function resend_otp(){

		var email = $("#email").val();


		if(email==''){
			alert('Email can not blank');
		}else{

			$.ajax({
	                  url: "<?=base_url().'home/resend_otp'?>",
	                  type: 'POST', 
	                  data: {email:email,},
	                  beforeSend:function(){
	                    
	                  },
	                  success: function(data){
	                  
	                      var obj=JSON.parse(data);
	                      if(obj.status==1){

	                        swal({
	                          title: obj.msg,
	                          // text: obj.msg,
	                          icon: "success",
	                        });

	                        $("#otp_verify").val(1);
	                        
	                      }else{

	                        	swal({
		                          title: obj.msg,
		                          // text: obj.msg,
		                          icon: "warning",
		                        })                                       
	                      }
	                      

	                  }
	        });

		}

	}


	// function check_email(val){
	// 	$(".email").val(val);
	// }

	// function check_name(val){
	// 	$(".name").val(val);
	// }
	
	$(document).ready(function() {

        $(".isnumber").keydown(function(e) {
          -1 !== $.inArray(e.keyCode, [46, 8, 9, 27, 13, 110, 190]) || 65 == e.keyCode && (!0 === e.ctrlKey || !0 === e.metaKey) || 67 == e.keyCode && (!0 === e.ctrlKey || !0 === e.metaKey) || 88 == e.keyCode && (!0 === e.ctrlKey || !0 === e.metaKey) || e.keyCode >= 35 && e.keyCode <= 39 || (e.shiftKey || e.keyCode < 48 || e.keyCode > 57) && (e.keyCode < 96 || e.keyCode > 105) && e.preventDefault()
        });
	});

	
</script>




	</body>
</html>

